@import "./_variables.scss";

$positionClasses: (
    display: (
        none: none,
        inline: inline,
        block: block,
        flex: flex,
        inline-block: inline-block,
        inline-flex: inline-flex,
    ),
    justify-content: (
        start: flex-start,
        end: flex-end,
        center: center,
        between: space-between,
        around: space-around, 
    ),
    align-content: (
        start: flex-start,
        end: flex-end,
        center: center,
        between: space-between,
        around: space-around,
    ),
    align-items: (
        start: flex-start,
        end: flex-end,
        center: center,
        between: space-between,
        around: space-around,
    ),

) !default;

.w100 {
    width: 100%;
}
.h100 {
    height: 100%;
}
.flex-wrap {
    flex-wrap: wrap;
}
.flex-nowrap {
    flex-wrap: nowrap;
}
.flex-column {
    flex-direction: column;
}
.flex-row {
    flex-direction: row;
}
.flex-grow {
    flex-grow: 1;
}
@each $breakpoint in map-keys($breakpoints) {
    @media (min-width: map-get($breakpoints, $breakpoint)) {
        .flex-wrap-#{$breakpoint} {
            flex-wrap: wrap;
        }
        .flex-nowrap-#{$breakpoint} {
            flex-wrap: nowrap;
        }
        .flex-grow-#{$breakpoint} {
            flex-grow: 1;
        }
    }
}

@each $class in map-keys($positionClasses) {
    $class-type: map-get($positionClasses, $class);
    @if type-of($class-type) == map {
        @each $item in map-keys($class-type) {
            .#{$class}-#{$item} {
                #{$class}: map-get($class-type, $item);
            }
            @each $breakpoint in map-keys($breakpoints) {
                .#{$class}-#{$breakpoint}-#{$item} {
                    @media (min-width: map-get($breakpoints, $breakpoint)) {
                        #{$class}: map-get($class-type, $item) !important;
                    }
                }
            }
        }
    } @else {
        .#{$class}-#{$class-type} {
            #{$class}: $class-type;
            @each $breakpoint in map-keys($breakpoints) {
                &-#{$breakpoint} {
                    @media (min-width: map-get($breakpoints, $breakpoint)) {
                        #{$class}: $class-type;
                    }
                }
            }
        } 
    }
}
